<?php

global $placeholder_script_default;
global $default_script_homepage;
global $default_script_detailproduct;
global $default_script_cart;
global $default_loop_export;

add_action('admin_menu', 'dreamroi_create_menu');

function dreamroi_create_menu() {
	add_menu_page('DreamROI', 'DreamROI', 'administrator', __FILE__, 'dreamroi_settings_page');
	add_action( 'admin_init', 'dreamroi_plugin_settings' );
}

function dreamroi_plugin_settings() {
	register_setting( 'dreamroi_settings_group', 'dreamroi_id' );
	register_setting( 'dreamroi_settings_group', 'dreamroi_id_all' );
	register_setting( 'dreamroi_settings_group', 'dreamroi_id_detailproduct' );
	register_setting( 'dreamroi_settings_group', 'dreamroi_id_addtocart' );
	register_setting( 'dreamroi_settings_group', 'dreamroi_id_order' );
	register_setting( 'dreamroi_settings_group', 'dreamroi_console_log' );
	register_setting( 'dreamroi_settings_group', 'dreamroi_webbox' );
	register_setting( 'dreamroi_settings_group', 'dreamroi_webbox_homepage' );
	register_setting( 'dreamroi_settings_group', 'dreamroi_webbox_detailproduct' );
	register_setting( 'dreamroi_settings_group', 'dreamroi_webbox_cart' );
	register_setting( 'dreamroi_settings_group', 'dreamroi_loop_export' );
}

function dreamroi_console($text) {
	if (get_option( 'dreamroi_console_log')) {
		?><script>console.log('<?= $text ?>');</script><?php
		return 1;
	} else {
		return 0;
	}
}


function dreamroi_settings_page() {
	$default_loop_export = "10000"; 
	$placeholder_script_default = "<style>
	...
</style>
<script>
	....
</script>";
$default_script_homepage="<style>
div.dreamroi_product_price {
    text-align: center;
}

div.dreamroi_product_name {
    text-align: center;
}

div.dreamroi-title {
  margin: 20px 0;
  font-weight: bold;
  text-align:center;
}

#dreamroi-container {
  margin: 50px 0;
}
</style>

<script>
   window.addEventListener('DOMContentLoaded', function(){
		var dreamroi_box = {
		mode: 'after',
		selector: '.woocommerce-products-header',
		cardWidth: 180,
		fields: ['image','name','price'],
		utm: {
			campaign: 'home'
		}
	};
	dreamroi_box.maxWidth = 'inherit';
	dreamroi_box.title = { content: 'Doporučeno přímo pro Vás' };
	roi.showBox(dreamroi_box);
});
</script>";
$default_script_detailproduct="<style>
div.dreamroi_product_price {
    text-align: center;
}

div.dreamroi_product_name {
    text-align: center;
}

div.dreamroi-title {
  margin: 20px 0;
  font-weight: bold;
  text-align:center;
}

#dreamroi-container {
  margin: 50px 0;
}
</style>

<script>
   window.addEventListener('DOMContentLoaded', function(){
		var dreamroi_box = {
		mode: 'after',
		selector: '.woocommerce-tabs',
		cardWidth: 100,
		fields: ['image','name','price'],
		utm: {
			campaign: 'product'
		}
	};
	dreamroi_box.maxWidth = 'inherit';
	dreamroi_box.title = { content: 'Doporučeno přímo pro Vás' };
	roi.showBox(dreamroi_box);
	});
</script>";
$default_script_cart="";
?>
  <div>
  <h2>DreamROI Settings</h2>
  <form method="post" action="options.php">
  <?php settings_fields( 'dreamroi_settings_group' ); ?>
  <?php do_settings_sections( 'dreamroi_settings_group' ); ?>
  <table>
  <tr>
	  <th scope="row" align="left">DreamROI ID</th>
	  <td><input type="text" name="dreamroi_id" value="<?php echo esc_attr(get_option('dreamroi_id') ); ?>" /></td>
  </tr>
  <tr>
	  <th scope="row" align="left">Enable DreamROI pixel? (ALL PAGES)</th>
	  <td><input name="dreamroi_id_all" type="checkbox" value="1" <?php checked( '1', get_option( 'dreamroi_id_all' ) ); ?> /></td>
  </tr>
  <tr>
	  <th scope="row" align="left">Enable DreamROI pixel on the products? (PRODUCT DETAIL)</th>
	  <td><input name="dreamroi_id_detailproduct" type="checkbox" value="1" <?php checked( '1', get_option( 'dreamroi_id_detailproduct' ) ); ?> /></td>
  </tr>
  <tr>
	  <th scope="row" align="left">Enable DreamROI conversion: AddToCart? (PRODUCT DETAIL)</th>
	  <td><input name="dreamroi_id_addtocart" type="checkbox" value="1" <?php checked( '1', get_option( 'dreamroi_id_addtocart' ) ); ?> /></td>
  </tr>
  <tr>
	  <th scope="row" align="left">Enable DreamROI conversion: Order? (THANKYOU PAGE)</th>
	  <td><input name="dreamroi_id_order" type="checkbox" value="1" <?php checked( '1', get_option( 'dreamroi_id_order' ) ); ?> /></td>
  </tr>
	  <tr><th>&nbsp;</th><td></td></tr>
  <tr>
	  <th scope="row" align="left">Show Webboxies?</th>
	  <td><input name="dreamroi_webbox" type="checkbox" value="1" <?php checked( '1', get_option( 'dreamroi_webbox' ) ); ?> /></td>
  </tr>
  <tr>
	  <th></th>
	  <td><br />Script for Homepage:<br />
		  <textarea cols='120' rows='10' name="dreamroi_webbox_homepage" placeholder="<?= $placeholder_script_default ?>"><?php echo esc_attr(get_option('dreamroi_webbox_homepage',$default_script_homepage) ); ?></textarea>
	  </td>
  </tr>
  <tr>
	  <th></th>
	  <td>Script for Detail Product:<br />
		  <textarea cols='120' rows='10' name="dreamroi_webbox_detailproduct" placeholder="<?= $placeholder_script_default ?>"><?php echo esc_attr(get_option('dreamroi_webbox_detailproduct',$default_script_detailproduct) ); ?></textarea>
	  </td>
  </tr>
  <tr>
	  <th></th>
	  <td>Script for Cart:<br />
		  <textarea cols='120' rows='10' name="dreamroi_webbox_cart" placeholder="<?= $placeholder_script_default ?>"><?php echo esc_attr(get_option('dreamroi_webbox_cart',$default_script_cart) ); ?></textarea>
	  </td>
  </tr>
	  <tr><th>&nbsp;</th><td></td></tr>
<tr>
	  <th scope="row" align="left">LOOP fo export: </th>
	  <td><input type="text" name="dreamroi_loop_export" value="<?php echo esc_attr(get_option('dreamroi_loop_export',$default_loop_export) ); ?>" /></td>
  </tr>
  <tr>
	  <th scope="row" align="left">- EXPORT - PRODUCTS - XML: </th>
	  <td><a href="<?= plugin_dir_url( __DIR__ ).'xml/products.php?loop='.esc_attr(get_option('dreamroi_loop_export')) ?>">URL to xml</a></td>
  </tr>
  <tr>
	  <th scope="row" align="left">- EXPORT - ORDERS - XML: </th>
	  <td><a href="<?= plugin_dir_url( __DIR__ ).'xml/orders.php?loop='.esc_attr(get_option('dreamroi_loop_export')) ?>">Click here and save file</a></td>
  </tr>
  <tr>
	  <th scope="row" align="left">- EXPORT - CLIENTS - CSV: </th>
	  <td><a href="<?= plugin_dir_url( __DIR__ ).'xml/clients.php?loop='.esc_attr(get_option('dreamroi_loop_export')) ?>">Click here and save file</a></td>
  </tr>
	  <tr><th>&nbsp;</th><td></td></tr>
  <tr>
	  <th scope="row" align="left">Show logs in console? <a href='https://balsamiq.com/support/faqs/browserconsole/'>HELP</a></th>
	  <td><input name="dreamroi_console_log" type="checkbox" value="1" <?php checked( '1', get_option( 'dreamroi_console_log' ) ); ?> /></td>
  </tr>
  </table>
  <?php  submit_button(); ?>
  </form>
  </div>
<?php
} 

/* DreamROI - tracking and conversions */
// Add to all pages
add_action('wp_head', 'dreamroi_all_pages');
function dreamroi_all_pages(){
	?>
	<?php 
	if (get_option('dreamroi_id_all')) { ?>
		<script defer src="https://app.dreamroi.com/client/v1/dreamroi.min.js"></script>
  		<?php if (get_option( 'dreamroi_console_log')) { ?>
			<script>window.addEventListener('DOMContentLoaded', function() { roi.init('<?= get_option('dreamroi_id') ?>',console) });</script>
		<?php } else { ?>
			<script>window.addEventListener('DOMContentLoaded', function() { roi.init('<?= get_option('dreamroi_id') ?>') });</script>
   		<?php }
		
		dreamroi_console('DreamROI ID:'.get_option('dreamroi_id')); // console.log
	}
		
	if (get_option('dreamroi_webbox')) { ?>
		<!-- DreamROI Box code -->
		<script defer src="https://app.dreamroi.com/client/v1/dreamroi-splide-box.min.js"></script> 
		<script defer src="https://app.dreamroi.com/client/v1/splide/splide.min.js"></script>
		<link rel="stylesheet" href="https://app.dreamroi.com/client/v1/splide/splide.min.css" media="print" onload="this.media='all'; this.onload=null;">
		<link rel="stylesheet" href="https://app.dreamroi.com/client/v1/dreamroi.min.css" media="print" onload="this.media='all'; this.onload=null;"> 
		<?php  
		dreamroi_console('Webbox: VIEW'); // console.log
	}
	
      // Add only to product detail
	 if (is_product()) {
		global $product;   
		 
		if (get_option('dreamroi_id_detailproduct')) { 
			?><script>window.addEventListener('DOMContentLoaded', function() {roi.viewProduct('<?= $product->get_id(); ?>')});</script><?php 
			
			dreamroi_console('This is a Product Detail - Product id:'.$product->get_id()); // console.log
		}

		if (get_option( 'dreamroi_webbox')) {
			 echo get_option('dreamroi_webbox_detailproduct');
		}
		 
		if (get_option('dreamroi_id_addtocart')) { 
				?><script>
			(function ($) {
				$( document ).on( 'click', '.single_add_to_cart_button', function(e) {	
				roi.addToCart('<?= $product->get_id(); ?>');
			});})(jQuery);</script><?php
		}
	}
	
	// homepage
	if(is_front_page()) {
		dreamroi_console('This is a Homepage'); // console.log
			
		if (get_option( 'dreamroi_webbox')) {
			 echo get_option('dreamroi_webbox_homepage');
		 }
	}
	
	// cart
	if(is_cart()) {
		dreamroi_console('This is a Cart'); // console.log
		
		if (get_option( 'dreamroi_webbox')) {
			 echo get_option('dreamroi_webbox_cart');
		 }
	}
}


// Add conversion script to thankyou page
add_action( 'woocommerce_thankyou', 'thankyou_custom', 5, 1 );
function thankyou_custom( $order_id ){
	if (get_option('dreamroi_id_order')) { 
		$order = wc_get_order( $order_id );
		$data = $order->get_data();

		$billing_email = $order->get_billing_email(); 
		$order_num = $data['id']; 
		$order_total = $data['total']-$data['shipping_total'];

		// Get order items
		$order_items = $order->get_items(); 

		// items for javascript array
		$dreamroi_items = '[';
		foreach( $order_items as $item_id => $item ){	
			$item_data = $item->get_data();

			$dreamroi_items .= '{';
			$dreamroi_items .= 'id:'.$item_data['product_id'].', ';
			$dreamroi_items .= 'quantity:'.$item_data['quantity'].', ';
			$dreamroi_items .= 'price:'.$item_data['total'];
			$dreamroi_items .= '},';
		}
		$dreamroi_items .= ']';


		if ( ! $order->has_status( 'failed' ) ) {
			?><script>window.addEventListener('DOMContentLoaded', function() { 
				roi.purchase(
					{
						id: <?= $order_num ?>, 
						email: '<?= $billing_email ?>', 
						total: <?= $order_total ?>, 
						items: <?= $dreamroi_items ?>
					}
				) 
			});</script><?php 

			dreamroi_console('Order - id:'.$order_num.' | email:'.$billing_email.' | total:'.$order_total.' | items:'.$dreamroi_items); // console.log	
		}
	}
}